<?php
define('SM_PATH','../../');

include_once(SM_PATH . 'functions/strings.php');
include_once(SM_PATH . 'include/validate.php');
include_once(SM_PATH . "plugins/webcalendar/includes/config.php");
include_once(SM_PATH . "plugins/webcalendar/config.php");
include_once('DB.php');

global $login, $onetimepad, $password, $_SESSION,
       $username, $db_host, $db_login, $db_password,
       $db_database, $db_type, $_COOKIE, $dsn, $db, $domain,
       $use_email_as_webcalendar_username, $calendar_groups,
       $calAdmin, $make_all_users_visible;

sqsession_is_active();

if ($_SESSION['Webcalendar'] != 1) {

// get global vars
//
$key = $_COOKIE['key'];
sqgetGlobalVar('onetimepad', $onetimepad);
sqgetGlobalVar('username', $username);
sqgetGlobalVar('domain', $domain);


// figure out webcalendar username, domain and email addr
//
$cal_username = $username;
$cal_domain = $domain;

if (strstr($cal_username,'@')) {
 $cal_email_address = $cal_username;
 $username_parts = explode('@',$cal_username);
 $cal_username = $username_parts[0];
 $cal_domain = $username_parts[1];
}
else
 $cal_email_address = $cal_username . '@' . $cal_domain;


// for better user differentiation in webcalendar,
// we can use the full email address as the username
//
if ($use_email_as_webcalendar_username)
   $cal_username = $cal_email_address;


// decrypt password
//
$password = OneTimePadDecrypt($key, $onetimepad);
$cal_password = md5($password);


// connect to database and see if user already
// has a webcalendar account
//
$dsn = "$db_type://$db_login:$db_password@$db_host/$db_database";
$db = DB::connect($dsn, false); //Connect to Database

$numrows = $db->getOne('SELECT count(*) FROM webcal_user WHERE cal_login="'.$cal_username.'"');


// if not, insert user into the proper tables
//
if($numrows == 0) {

   // insert brand new user
   //
   $result = $db->query("INSERT into webcal_user (cal_login,cal_passwd,cal_email) VALUES ('".$cal_username."','$cal_password','".$cal_email_address."')");
   if ($make_all_users_visible)
      $result = $db->query("INSERT into webcal_group_user (cal_group_id,cal_login) VALUES ('1','".$cal_username."')");


// for users who are already in database...
//
} else {

   // update user's entry in webcalendar in case
   // user has recently changed their email password
   //
   $result = $db->query("UPDATE webcal_user set cal_passwd = '$cal_password' WHERE cal_login = '$cal_username'");

}



// if user has defined special groups, update them now
//
if (sizeof($calendar_groups))
   update_group_calendars($cal_username, $calendar_groups, $calAdmin, $db);



// webcalendar uses "login" as its user name variable
//
$login = $cal_username;
sqsession_register('1', 'Webcalendar');
}
// ##################################
// into the webcalendar code...
//
include_once "includes/config.php";
include_once "includes/php-dbi.php";
include_once "includes/functions.php";
include_once "includes/$user_inc";
include_once "includes/connect.php";

load_global_settings ();

if ( ! empty ( $last_login ) )
  $login = "";

if ( $remember_last_login == "Y" && empty ( $login ) ) {
  $last_login = $login = $webcalendar_login;
}

load_user_preferences ();

/* '_once' Added by ri_once */ include_once "includes/translate.php";

// see if a return path was set
if ( ! empty ( $return_path ) ) {
  $url = $return_path;
} else {
  $url = "index.php";
}

// calculate path for cookie
if ( empty ( $PHP_SELF ) )
  $PHP_SELF = $_SERVER["PHP_SELF"];
$cookie_path = str_replace ( "login.php", "", $PHP_SELF );
//echo "Cookie path: $cookie_path\n";

if ( $single_user == "Y" ) {
  // No login for single-user mode
  do_redirect ( "index.php" );
} else if ( $use_http_auth ) {
  // There is no login page when using HTTP authorization
  do_redirect ( "index.php" );
} else {
  if ( ! empty ( $login ) && ! empty ( $password ) ) {
    $login = trim ( $login );
    $password = md5($password);
    if ( user_valid_login ( $login, $password) ) {
      user_load_variables ( $login, "" );
      // set login to expire in 365 days
      srand((double) microtime() * 1000000);
      $salt = chr( rand(ord('A'), ord('z'))) . chr( rand(ord('A'), ord('z')));
      $encoded_login = encode_string ( $login . "|" . crypt($password, $salt) );

      if ( $remember == "yes" )
        SetCookie ( "webcalendar_session", $encoded_login,
          time() + ( 24 * 3600 * 365 ), $cookie_path );
      else
        SetCookie ( "webcalendar_session", $encoded_login, 0, $cookie_path );
      // The cookie "webcalendar_login" is provided as a convenience to
      // other apps that may wish to find out what the last calendar
      // login was, so they can use week_ssi.php as a server-side include.
      // As such, it's not a security risk to have it un-encoded since it
      // is not used to allow logins within this app.  It is used to
      // load user preferences on the login page (before anyone has
      // logged in) if $remember_last_login is set to "Y" (in admin.php).
      if ( $remember == "yes" )
        SetCookie ( "webcalendar_login", $login,
          time() + ( 24 * 3600 * 365 ), $cookie_path );
      else
        SetCookie ( "webcalendar_login", $login, 0, $cookie_path );
      do_redirect ( $url );
    }
  }
  // delete current user
  SetCookie ( "webcalendar_session", "", 0, $cookie_path );
  // In older versions the cookie path had no trailing slash and NS 4.78
  // thinks "path/" and "path" are different, so the line above does not
  // delete the "old" cookie. This prohibits the login. So we delete the
  // cookie with the trailing slash removed
  if (substr($cookie_path, -1) == '/')
    SetCookie ( "webcalendar_session", "", 0, substr($cookie_path, 0, -1)  );
}

?>
<HTML>
<HEAD>
<TITLE><?php etranslate($application_name)?></TITLE>
<SCRIPT LANGUAGE="JavaScript">
// error check login/password
function valid_form ( form ) {
  if ( form.login.value.length == 0 || form.password.value.length == 0 ) {
    alert ( "<?php etranslate("You must enter a login and password")?>." );
    return false;
  }
  return true;
}
function myOnLoad() {
  <?php if ( $plugins_enabled ) { ?>
  if (self != top)  {
    window.open("login.php","_top","");
    return;
  }
  <?php } ?>
  document.forms[0].login.focus();
  <?php
    if ( ! empty ( $login ) ) echo "document.forms[0].login.select();"
  ?>
  }
}
</SCRIPT>
<?php /* '_once' Added by ri_once */ include_once "includes/styles.php"; ?>
</HEAD>
<BODY BGCOLOR="<?php echo $BGCOLOR;?>"
ONLOAD="myOnLoad();" CLASS="defaulttext">

<H2><FONT COLOR="<?php echo $H2COLOR?>"><?php etranslate($application_name)?></FONT></H2>

<?php
if ( ! empty ( $error ) ) {
  print "<FONT COLOR=\"#FF0000\"><B>" . translate("Error") .
    ":</B> $error</FONT><P>\n";
}
?>
<FORM NAME="login_form" ACTION="login.php" METHOD="POST" ONSUBMIT="return valid_form(this)">

<?php
if ( ! empty ( $return_path ) )
  echo "<INPUT TYPE=\"hidden\" NAME=\"return_path\" VALUE=\"" .
    htmlentities ( $return_path ) . "\">\n";
?>

<TABLE BORDER=0>
<TR><TD><B><?php etranslate("Username")?>:</B></TD>
  <TD><INPUT NAME="login" SIZE=10 VALUE="<?php if ( isset ( $last_login ) ) echo $last_login;?>" TABINDEX="1"></TD></TR>
<TR><TD><B><?php etranslate("Password")?>:</B></TD>
  <TD><INPUT NAME="password" TYPE="password" SIZE=10 TABINDEX="2"></TD></TR>
<TR><TD COLSPAN=2><INPUT TYPE="checkbox" NAME="remember" VALUE="yes" <?php if ( ! empty ( $remember ) && $remember == "yes" ) echo "CHECKED"; ?>> <?php etranslate("Save login via cookies so I don't have to login next time")?></TD></TR>
<TR><TD COLSPAN=2><INPUT TYPE="submit" VALUE="<?php etranslate("Login")?>" TABINDEX="3"></TD></TR>
</TABLE>

</FORM>

<P>
<?php 
       if (!isset($public_access)) $public_access = FALSE;
       if ( $public_access == "Y" ) { ?>
  <A CLASS="navlinks" HREF="week.php"><?php etranslate("Access public calendar")?></A><P>
<?php } ?>

<?php
if ( $demo_mode == "Y" ) {
  // This is used on the sourceforge demo page
  echo "Demo login: user = \"demo\", password = \"demo\" <P>";
}
?>
<BR><BR><BR>
<FONT SIZE="-1">
<?php etranslate("cookies-note")?>
<P>
<HR><P>
<A HREF="<?php echo $PROGRAM_URL ?>" CLASS="aboutinfo"><?php echo $PROGRAM_NAME?></A>
</FONT>
<? echo  $key. " Hi mom ";?>
</BODY>
</HTML>


<?php 

// looks in the specially defined group calendars
// and adds the current user to any of the calendars
// they should belong to if they are not already 
// added
//
function update_group_calendars($cal_username, $calendar_groups, $calAdmin, $db)
{

   foreach ($calendar_groups as $calname => $calendar_users)
   {

      // check each user name listed in each calendar
      //
      foreach ($calendar_users as $user)
      {

         // if we find a matching username
         //
         if (preg_match('/' . str_replace(array('?', '*'), array('\w{1}', '.*?'), 
                              strtoupper($user)) . '/', strtoupper($cal_username)))
         {

            // query the database to see if this user already
            // has access to this group calendar
            //
            // first, get group ID
            //
            $groupID = $db->getOne('SELECT cal_group_id FROM webcal_group WHERE cal_name=\'' . $calname . '\'');


            // if the group calendar didn't exist, create it
            //
            if (!is_numeric($groupID)) 
            {
               $groupID = $db->getOne('SELECT max(cal_group_id) FROM webcal_group');
               if (!is_numeric($groupID)) $groupID = 1;  // yes, this starts at two
               $result = $db->query('INSERT INTO webcal_group(cal_group_id, cal_owner, cal_name, cal_last_update) VALUES(' 
                       . (++$groupID) . ', \'' . $calAdmin . '\', \'' 
                       . $calname . '\', \'' . date("Ymd") . '\')');
            }
            

            // look for user in this calendar
            //
            $numrows = $db->getOne('SELECT count(*) FROM webcal_group_user WHERE cal_group_id = ' . $groupID . ' AND cal_login = \'' . $cal_username . '\'');
            
  
            // insert user in this group if wasn't there
            //
            if ($numrows !== 1)
            {
               $result = $db->query('INSERT INTO webcal_group_user(cal_group_id, cal_login) VALUES(\'' . $groupID . '\', \'' . $cal_username . '\')');
            }

         }

      }

   }

}

?>
